<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<?php // Jax Petition Book (based on Jax Guestbook) v3.06 - jax_guestbook.php

$form_mailer = "formmailer.php";
// -> siehe Zeile 340

/*
	Project:        Guestbook (visitor's book)
	Version:        3.06 (with optional database support)
	Interpreter:    PHP 4.x+, 4.1x+ (prepared for register_globals = off)
	Code & Design:  Andreas John aka Jack (tR)
	Homepage:       www.jtr.de/scripting/php/
	License:        (C) Copyright 2001-2002 by Andreas John (jack@jtr.de)

   --------------------------------------------------------------

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public
	License	along with this program; if not, write to the
	Free Software Foundation, Inc.,
	59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.

        (or see http://www.fsf.org/copyleft/gpl.html)
        
*/

// Global variables (which has to be fitted)
require ( "globals.inc.php" );

// Include file for the language
require ( "language/" .$languagepack . ".inc.php" );


if ( $data_source == "mysql" )
{
	// include class for database support
	require ( "mysql.inc.php" );

	// prepare object for database access
	$db             = new mysql;
	$db->name       = $guestbookfile;
	$db->server     = $db_server;
	$db->login      = $db_login;
	$db->password   = $db_password;
	$db->database   = $db_database;
	$db->init();

	$bf             = new mysql;
	$bf->name       = $blocking_file;
	$bf->server     = $db_server;
	$bf->login      = $db_login;
	$bf->password	= $db_password;
	$bf->database	= $db_database;
	$bf->init();
}

if ( $data_source == "csvfile" )
{
	// include class for csv-textfile support
	require ( "csvfile.inc.php" );

	// prepare object for file access
	$db         = new csvfile;
	$db->name   = $guestbookfile;
	$db->init();

	$bf         = new csvfile;
	$bf->name   = $blocking_file;
	$bf->init();
}

?>

<html>
  <head>
  <title><?php echo $htmltitle; ?></title>
  <meta http-equiv="Content-Type" content="text/html; charset=<?php echo $charset ?>">
  <link rel="stylesheet" href="<?php echo $css_file; ?>">
  <meta http-equiv="expires" content="1">
</head>

<?
	// JavaScript checking routines for the HTML input forms...
	require "tests.js.inc.php";
?>

<body link="#FFFFFF" vlink="#FFFFFF" alink="#FFFFFF">
<h3 align="center" class="guestbook"><?php echo $htmltitle; ?></h3>

<?php

	if ( !empty( $HTTP_GET_VARS[ "do"] ) && $HTTP_GET_VARS[ "do" ] == "ask_action" )
	{
$question_form = <<<QF
<table width="100%" height="100%" border="0" cellpadding="0" cellspacing="0">
<tr><td>
<table border="1" width="50%" valign="middle" align="center" cellspacing="0" class="guestbook" bordercolor="#000000"
<tr><td>
<form name="decision_form" action="" onSubmit="Ergebnis();return false;">
<table border="0" cellpadding="10" cellspacing="0">
<tr align="middle" valign="center">
<td colspan="2" align="left"><b>Vielen Dank fr Ihren Eintrag!</b><br>Mchten Sie auch an unserer e-mail-Aktion fr ### teilnehmen?</td>
</tr>
<tr align="middle" valign="center">
<td><input type="button" name="yes" width="60" class="button" value=" Ja " onClick="send_data(this.name)"></td>
<td><input type="button" name="no" width="60" class="button" value=" Nein " onClick="send_data(this.name)"></td>

</tr>
</table>
</form>
</td></tr></table>
</td></tr></table>
QF;

echo $question_form;
exit;

	}



	function block_ip()
	// Task:  blocks the IP address of a visitor for a short time
	{
		global $blocking_period, $bf, $REMOTE_ADDR;
		
		// duration of the block (more than 3 hours are senseless!)
		$stamp = intval( gmdate( "mdG" ) ) + $blocking_period;

		$dummy = array();
		$dummy["ip"] = strval( $REMOTE_ADDR );
		$dummy["timestamp"] = $stamp;

		$bf->append( $dummy );
	}

	function check_ip( )
	// Task:   checks whether the ip address of the surfer is invalid
	//
	// Input:  none
	//
	// Output: none
	{

		global $_like_you_anyway, $bf, $REMOTE_ADDR;

		$stamp = intval( gmdate( "mdG" ) );

		$max = $bf->entries();
		$position = $bf->find_entry( $REMOTE_ADDR );

		if ( $position < $max )
		{
			$entry = array();
			$bf->get_entry( $position, $entry );

			// does the visitor try to spam the guestbook?
			if ( ($entry["ip"] == $REMOTE_ADDR ) and 
			($stamp <= $entry["timestamp"]) )
			{
				echo $_like_you_anyway;
				exit();
			}
		}

	}

	function email_notification( )
	// Task:   notifies the webmaster by e-mail if a new guestbook entry was made
	//
	// Input:  none
	//
	// Output: none
	{

		global $administrator_address, $_new_entry, $_guestbook, $guestbook_id, $SERVER_NAME, $SCRIPT_NAME;

		$mailheader =
		trim( "From: ".$_guestbook." <jax_guestbook@".$SERVER_NAME.">\n"
		. "Reply-To: jax_guestbook@".$SERVER_NAME."\n"
		. "X-Mailer: PHP " . phpversion() );

		$gb_url   = "http://".$SERVER_NAME.$SCRIPT_NAME
		            .'?guestbook_id='.$guestbook_id;

		$message  = trim( $_new_entry."\n\n".$gb_url." !\n" );
		$subject  = trim( $_new_entry."\n" );
		$email    = trim( $administrator_address );

		@mail( $email, $subject, $message, $mailheader );

	}

	function wrap_words( $bad_text, $max_chars )
	// Task:   Forces line and word wraps in the text
	//
	// Input:  $bad_text  -> the Text
	//         $max_chars -> maximum of chars each line
	//
	// Output: $nice_text -> the "clean" text
	{

		$lines = explode( " ", $bad_text );

		$nice_text = "";
		for ( $i=0; $i < count($lines); $i++ )
		{
			if ( strlen($lines[$i]) > $max_chars )
			{
				$lines[$i] = chunk_split( $lines[$i], $max_chars , " " );
			}
			$nice_text .= $lines[$i]." ";
		}

		return $nice_text;

	}

	function clean_html_input( $bad_text, $len )
	// Task:   cleans HTML form input (removes tags and cuts oversize)
	//
	// Input:  $bad_text  -> the html form input text
	//         $len       -> maximum length of the input text
	// Output: $nice_text -> the "clean" input text
	{
		$nice_text = strip_tags( $bad_text );

		// Shortens (if neccessary)
		$nice_text = substr( $nice_text, 0, $len );
		
		return $nice_text;
		
	}
//----------------------------------------------------------------------------
//	Guestbook entry was sent, save!
//----------------------------------------------------------------------------

	if ( !empty( $HTTP_GET_VARS[ "action"] ) && $HTTP_GET_VARS[ "action" ] == "post" )
	{

		check_ip();

		if ( 
		
		empty( $HTTP_POST_VARS[ "name" ] ) ||
		empty( $HTTP_POST_VARS[ "street" ] ) ||
		empty( $HTTP_POST_VARS[ "plz" ] ) ||
		empty( $HTTP_POST_VARS[ "city" ] ) ||
		empty( $HTTP_POST_VARS[ "mail" ] )
		) { exit; }


		if ( !empty( $HTTP_POST_VARS[ "title" ] ) )
		  $title = clean_html_input( $HTTP_POST_VARS[ "title" ], 30 );
		else
		  $title = "";

		if ( !empty( $HTTP_POST_VARS[ "name" ] ) )
		  $name = clean_html_input( $HTTP_POST_VARS[ "name" ], 50 );
		else
		  $name = "";

		if ( !empty( $HTTP_POST_VARS[ "firstname" ] ) )
		  $firstname = clean_html_input( $HTTP_POST_VARS[ "firstname" ], 50 );
		else
		  $firstname = "";		  

		if ( !empty( $HTTP_POST_VARS[ "profession" ] ) )
		  $profession = clean_html_input( $HTTP_POST_VARS[ "profession" ], 100 );
		else
		  $profession = "";
		  
		if ( !empty( $HTTP_POST_VARS[ "street" ] ) )
		  $street = clean_html_input( $HTTP_POST_VARS[ "street" ], 50 );
		else
		  $street = "";		  

		if ( !empty( $HTTP_POST_VARS[ "plz" ] ) )
		  $plz = clean_html_input( $HTTP_POST_VARS[ "plz" ], 7 );
		else
		  $plz = "";		  

		if ( !empty( $HTTP_POST_VARS[ "city" ] ) )
		  $city = clean_html_input( $HTTP_POST_VARS[ "city" ], 40 );
		else
		  $city = "";

		if ( !empty( $HTTP_POST_VARS[ "mail" ] ) )
		  $mail = clean_html_input( $HTTP_POST_VARS[ "mail" ], 100 );
		else
		  $mail = "";
		  
		// Force line breaks if lines too long!
		// $msg = wrap_words( $msg, 55 );

		$new_entry = array();

		$new_entry["date"]      = gmdate( "Y-m-d" );
		$new_entry["time"]      = gmdate( "H:i:s" );
		$new_entry["ip"]        = $REMOTE_ADDR;
		$new_entry["title"]     = $title;
		$new_entry["name"]      = $name;
		$new_entry["firstname"] = $firstname;
		$new_entry["profession"]= $profession;		
		$new_entry["street"]    = $street;
		$new_entry["plz"]       = $plz;
		$new_entry["city"]      = $city;
		$new_entry["mail"]      = $mail;
		$db->append( $new_entry );

			if ( $administrator_notification == true )
			{
				email_notification( );
			}

			if ( $filter_multiposting == true )
			{
				block_ip();
			}

	$question_form = <<<QF
<script type="text/javascript">
<!--

 function send_data( selection )
  {
  	var thisform = document.decision_form;

  	thisform.method = "post";

  	if ( selection == "yes" ) { thisform.action = '$form_mailer?action=enter&name=$name&firstname=$firstname&mail=$mail' };
  	if ( selection == "no" )  { thisform.action = '$PHP_SELF' };

    	thisform.submit();
  }
 
//-->
</script>
<table width="100%" height="100%" border="0" cellpadding="0" cellspacing="0">
<tr><td>
<table border="1" width="50%" valign="middle" align="center" cellspacing="0" class="guestbook" bordercolor="#000000"
<tr><td>
<form name="decision_form" action="" onSubmit="Ergebnis();return false;">
<table border="0" cellpadding="10" cellspacing="0">
<tr align="middle" valign="center">
<td colspan="2" align="left"><b>Vielen Dank fr Ihren Eintrag!</b><br>Mchten Sie auch an unserer e-mail-Aktion fr ### teilnehmen?</td>
</tr>
<tr align="middle" valign="center">
<td><input type="button" name="yes" width="60" class="button" value=" Ja " onClick="send_data(this.name)"></td>
<td><input type="button" name="no" width="60" class="button" value=" Nein " onClick="send_data(this.name)"></td>

</tr>
</table>
</form>
</td></tr></table>
</td></tr></table>
QF;

	echo $question_form;
	exit;

		
	}

   //	Show current page of the Guestbook!

	if ( !empty( $HTTP_GET_VARS[ "page" ] ) )
	{ 
		$page = $HTTP_GET_VARS[ "page" ];
	}
	else $page = 1;
	
	$entries = $db->entries();

	$maxpages = ceil( $entries / $entries_per_page );

	if ( $page < $maxpages )
	{
		$nextpage = $page+1;
	}
	else
	{
		$nextpage = $maxpages;
	}

	$lastpage = $page-1;


require ( "form.inc.php" );

$pagenavigation = <<<NAV
<p align="center" id="page_nav">&lt; <a href="$PHP_SELF?page=$lastpage&language=$languagepack&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs">$_last</a> | $page $_of $maxpages |
<a href="$PHP_SELF?page=$nextpage&language=$languagepack&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs">$_next</a> &gt;</p>
NAV;

echo $pagenavigation;

echo "<p>&nbsp;</p><p align=\"center\"><b>Bisher untersttzen $entries Personen die ###-Aktion:</b></p>";

?>

<table border="0" width="600" align="center">
  <tr>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
    <td>&nbsp;</td>    
    <td>&nbsp;</td>
  </tr>

<?php

	// Task:   Print a Guestbook entry in formatted way
	//
	// Input:  $token	: array with the single entries
	//
	// Output: String, ready for output...
	//
	function showentry( $entry )
	{

		global $languagepack, $_yearsold, $_from, $input_icq, $fit_timezone,
		$timezone_offset;

		/*$date   = $entry["date"];
		$time   = $entry["time"];

// fit time to users time zone
		if ( $fit_timezone )
		{
			global $HTTP_GET_VARS;

			if ( empty( $HTTP_GET_VARS[ "gmt_ofs" ] ) 
			&& !empty( $timezone_offset ) )
			{
				$gmt_ofs = $timezone_offset;
			}
			else 
				if ( !empty( $HTTP_GET_VARS[ "gmt_ofs"] ) )
				{
					$gmt_ofs = $HTTP_GET_VARS[ "gmt_ofs" ];
				}
				else
				{
					$gmt_ofs = 0;	
				}

			if ( !empty( $gmt_ofs ) && ( $gmt_ofs != 0 ) )
			{
				$dt = explode( "-", $date );
				$tm = explode( ":", $time );
				$timestamp = mktime( $tm[0], $tm[1], $tm[2], $dt[1],
				$dt[2], $dt[0] ) + (60*60*$gmt_ofs);
				$date = date( "Y-m-d", $timestamp );
				$time = date( "H:i:s", $timestamp );
			}
			if ($gmt_ofs > 0) $gmt_sign = "+"; else $gmt_sign = " ";
			$timezone = "(GMT $gmt_sign $gmt_ofs)";
		}*/

		$title  = $entry["title"];
		$firstname = $entry["firstname"];
		$name   = $entry["name"];
		$profession = $entry["profession"];
		$mail   = $entry["mail"];
		$street = $entry["street"];
		$plz    = $entry["plz"];
		$city   = $entry["city"];

		// Generate output string


		$outputstr = '<tr><td valign="top" id="guestbook_name">' . $title. " ". $firstname. " ". $name . "</td><td id=\"guestbook_profession\">".$profession . "</td>\n".'<td id="guestbook_address" valign="top">'
		. $street . ", " . $plz . " " . $city . "</td></tr>\n";

		return $outputstr;

	} // showentry

//----------------------------------------------------------------------------
// 	Show entries on the current Guestbook page
//----------------------------------------------------------------------------

	// Line of the file from where to start
	$first_entry = $entries - ( $page * $entries_per_page ) + 1;
	if ($first_entry < 1) { $first_entry = 1; }

	// Line of the file where to end
	$last_entry = $entries - ( ($page-1) * $entries_per_page );
	if ($last_entry < 1) { $last_entry = 1; }

	// Output entries sorted by LIFO

	$entrynum = $last_entry;

	$entry = array();
	$db->get_entrylist( $first_entry-1, $last_entry-1, $entry );

	$keys = array_keys( $entry );
	$keys = array_reverse( $keys );

	$i = $last_entry;
	foreach ($keys as $key)
	{
		echo showentry( $entry[$key] );
		$i--;
	}

?>
  <tr>
    <td>&nbsp;</td>    
    <td>&nbsp;</td>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>
</table>

<?php

echo $pagenavigation;

// Remove expired IP blocks

	$stamp = intval( gmdate( "mdG" ) );

	$max = $bf->entries();
	for ( $i=0; $i<$max; $i++ )
	{
		$entry = array();
		$bf->get_entry( $i, $entry );

		if ( $stamp > $entry["timestamp"] )
		{
			$bf->delete( $position );
		}
	}

?>

<p>&nbsp;</p>
<!-- Please don't remove the link to the author's website!!! -->
<p><font size="1" color="#BBBBBB">Petition book (based on Jax Guestbook) v3.06 by Jack (tR),
<a href="http://www.jtr.de/scripting/php">www.jtr.de/scripting/php</a>
</font></p>

</body>
</html>
