<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<?php // Petitionbook based on Jax Guestbook v3.06 - guestbook.admin.php

/*
	Project:        Guestbook (visitor's book)
	Version:        3.06 (with optional database support)
	Interpreter:    PHP 4.x+, 4.1x+ (prepared for register_globals = off)
	Code & Design:  Andreas John aka Jack (tR)
	Homepage:       www.jtr.de/scripting/php/
	License:        (C) Copyright 2001-2002 by Andreas John (jack@jtr.de)

   --------------------------------------------------------------

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public
	License	along with this program; if not, write to the
	Free Software Foundation, Inc.,
	59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.

     (or see http://www.fsf.org/copyleft/gpl.html)
        
*/
	// fit if nescessary:
	$path_to_guestbook = "../";

	require( $path_to_guestbook."globals.inc.php" );

	// include language file
	require ( $path_to_guestbook."language/" .$languagepack . ".inc.php" );

	$PHP_SELF = $_SERVER[ "PHP_SELF" ];

	if (!empty( $HTTP_GET_VARS["gmt_ofs"] ) ) 
	{ $gmt_ofs = $HTTP_GET_VARS["gmt_ofs"]; }
	else
	{ $gmt_ofs = 0; }

	if ( $data_source == "mysql" )
	{
		// include class for database support
		require ( $path_to_guestbook."mysql.inc.php" );

		$db           = new mysql;
		$db->name     = $guestbookfile;
		$db->server   = $db_server;
		$db->login    = $db_login;
		$db->password = $db_password;
		$db->database = $db_database;
		$db->init();
	}

	if ( $data_source == "csvfile" )
	{
		// include class for .csv-file support
		require ( $path_to_guestbook."csvfile.inc.php" );

		$db       = new csvfile;
		$db->name = $path_to_guestbook.$guestbookfile;
		$db->init();
	}
?>

<html>
<head>
	<title><?php echo $_guestbook_admin_tool ?></title>
	<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $charset; ?>">
	<style type="text/css">
	<!--
	body {  background-color: #0066AA; font-family: Arial, Helvetica, sans-serif; font-size: 14px; color: #FFFFFF}
	td { background-color: #0066AA; font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #FFFFFF }
	a:link { color:#00FFFF; ; font-family: Arial, Helvetica, sans-serif}
	a:active {  color: #00FFFF}
	a:visited {  color: #FFFFFF}
	a:hover {  color: #FF0000}
	table.guestbook {  background-color: #006699; color: #FFFFFF; border-color: #000000 black black; font-size: smaller}
	table.guestbook td { font-size: 14px}
	#page_nav { font-size: smaller}
	#guestbook_date { color: #BBCCEE; font-size: 10px}
	#guestbook_name { font-family: "Times New Roman", Times, serif; font-style: italic; font-size: small}
	#guestbook_ip { font-size: 10px; color: #0066AA; font-weight: bolder; background-color: #FFFF00}
	#guestbook_message { font-size: 12px}
	#guestbook_counter { font-size: 24px; color: #FFFFFF; font-weight: bolder}
	#guestbook_edit { font-size: 12px; color: #0066AA; font-weight: bolder; background-color: #CCCCCC}
	-->
	</style>
</head>

<body>
<h3 align="center"><? echo $_guestbook_admin_tool ?></h3>

<?php

	if ( !empty( $HTTP_GET_VARS["action"] ) && $HTTP_GET_VARS["action"] == "delete" )
	{
		$entry = $HTTP_GET_VARS["entry"];
		$page = $HTTP_GET_VARS["page"];
		$db->delete( $entry-1 );
		echo "$_entry $entry $_deleted...<br>";
		echo '<meta http-equiv="refresh" content="2;URL='.$PHP_SELF."?action=list&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs&page=$page".'">';
		exit;
	}

	if ( !empty( $HTTP_GET_VARS["action"] ) and $HTTP_GET_VARS["action"] == "change" )
	{
		$new = array();
		$new["time"]     = $HTTP_POST_VARS["time"];
		$new["date"]     = $HTTP_POST_VARS["date"];
		$new["ip"]       = $HTTP_POST_VARS["ip"];
		$new["icq"]      = $HTTP_POST_VARS["icq"];
		$new["name"]     = $HTTP_POST_VARS["name"];
		$new["age"]      = $HTTP_POST_VARS["age"];
		$new["location"] = $HTTP_POST_VARS["city"];
		$new["mail"]     = $HTTP_POST_VARS["mail"];
		$new["homepage"] = $HTTP_POST_VARS["homepage"];
		$new["message"]  = ereg_replace("(\r\n|\n|\r)", "<br>", $HTTP_POST_VARS["message"] );

		$entry = $HTTP_GET_VARS["entry"];
		$page = $HTTP_GET_VARS["page"];
		$db->change( $entry-1, $new );
		echo "$_entry $entry $_changed...<br>";
		echo '<meta http-equiv="refresh" content="2;URL='.$PHP_SELF."?action=list&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs&page=$page".'">';
		exit;
	}


	if ( !empty( $HTTP_GET_VARS["action"] ) && $HTTP_GET_VARS["action"] == "edit" )
	{
		$entry = $HTTP_GET_VARS["entry"];
		$db->get_entry( $entry-1, $old );
		$old_time     = $old["time"];
		$old_date     = $old["date"];
		$old_ip       = $old["ip"];
		$old_icq      = $old["icq"];
		$old_name     = $old["name"];
		$old_age      = $old["age"];
		$old_city     = $old["location"];
		$old_email    = $old["mail"];
		$old_homepage = $old["homepage"];
		$old_message  = ereg_replace( "<br>", "\n", $old["message"] );
		$page = $HTTP_GET_VARS["page"];

echo <<< MENU
<form name="sendform" method="post" action="$PHP_SELF?action=change&entry=$entry&gmt_ofs=$gmt_ofs&page=$page">
  <table border="1" align="center" cellspacing="0" class="guestbook" bordercolor="#000000">
    <tr>
      <td>
        <table width="100%" border="0" height="100%">
          <tr>
            <td>&nbsp;</td>
            <td colspan="2">&nbsp;</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>$_date:</td>
            <td>$_time:</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>
              <input type="text" name="date" size="30" value="$old_date">
            </td>
            <td>
              <input type="text" name="time" size="30" value="$old_time">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>$_ip:</td>
            <td>$_icq:</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>
              <input type="text" name="ip" size="30" value="$old_ip">
            </td>
            <td>
              <input type="text" name="icq" size="30" value="$old_icq">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>$_name:</td>
            <td>$_mailaddress</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>
              <input type="text" name="name" size="30" value="$old_name">
            </td>
            <td>
              <input type="text" name="mail" size="30" value="$old_email">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>$_age:</td>
            <td>$_city:</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>
              <input type="text" name="age" size="30" value="$old_age">
            </td>
            <td>
              <input type="text" name="city" size="30" value="$old_city">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td colspan="2">&nbsp; </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>$_homepage</td>
            <td>&nbsp; </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td class="guestbook" colspan="3">
              <input type="text" name="homepage" size="60" value="$old_homepage">
            </td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td class="guestbook" colspan="2">&nbsp;</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td colspan="2">$_comment:</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;&nbsp;&nbsp;</td>
            <td colspan="2">
              <textarea name="message" rows="5" cols="50">$old_message</textarea>
            </td>
            <td>&nbsp;&nbsp;&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td colspan="3">
              <input type="submit" name="Button" value="$_change">
            </td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td colspan="2">&nbsp;</td>
            <td>&nbsp;</td>
          </tr>
        </table>
      </td>
    </tr>
  </table>
</form>
MENU;

exit;

}

if ( !empty( $HTTP_GET_VARS["action"] ) && $HTTP_GET_VARS["action"] == "list" )
{

   //	Show current page of the Guestbook!

	if ( !empty( $HTTP_GET_VARS[ "page" ] ) )
	{ 
		$page = $HTTP_GET_VARS[ "page" ];
	}
	else $page = 1;
	
	$entries = $db->entries();

	$maxpages = ceil( $entries / $entries_per_page );

	if ( $page < $maxpages )
	{
		$nextpage = $page+1;
	}
	else
	{
		$nextpage = $maxpages;
	}

	$lastpage = $page-1;


$pagenavigation = <<<NAV
<p align="center" id="page_nav">&lt; <a href="$PHP_SELF?action=list&page=$lastpage&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs">$_last</a> | $page $_of $maxpages |
<a href="$PHP_SELF?action=list&page=$nextpage&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs">$_next</a> &gt;</p>
NAV;

echo '<p>&nbsp;</p><p><a href="'.$PHP_SELF.'">'.$_back_to_main_menu.'</a></p><p>&nbsp;</p>';
echo $pagenavigation;

echo <<<TABSTART
<table width="75%" border="0" align="center">
  <tr>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
    <td>&nbsp;</td>    
  </tr>
TABSTART;


	// Task:   Print a Guestbook entry in formatted way
	//
	// Input:  $token	: array with the single entries
	//
	// Output: String, ready for output...
	//
	function showentry( $entry )
	{

		global $languagepack, $_yearsold, $_from, $input_icq, $fit_timezone,
		$timezone_offset;

		/*$date   = $entry["date"];
		$time   = $entry["time"];

// fit time to users time zone
		if ( $fit_timezone )
		{
			global $HTTP_GET_VARS;

			if ( empty( $HTTP_GET_VARS[ "gmt_ofs" ] ) 
			&& !empty( $timezone_offset ) )
			{
				$gmt_ofs = $timezone_offset;
			}
			else 
				if ( !empty( $HTTP_GET_VARS[ "gmt_ofs"] ) )
				{
					$gmt_ofs = $HTTP_GET_VARS[ "gmt_ofs" ];
				}
				else
				{
					$gmt_ofs = 0;	
				}

			if ( !empty( $gmt_ofs ) && ( $gmt_ofs != 0 ) )
			{
				$dt = explode( "-", $date );
				$tm = explode( ":", $time );
				$timestamp = mktime( $tm[0], $tm[1], $tm[2], $dt[1],
				$dt[2], $dt[0] ) + (60*60*$gmt_ofs);
				$date = date( "Y-m-d", $timestamp );
				$time = date( "H:i:s", $timestamp );
			}
			if ($gmt_ofs > 0) $gmt_sign = "+"; else $gmt_sign = " ";
			$timezone = "(GMT $gmt_sign $gmt_ofs)";
		}*/

		$date   = $entry["date"];
		$time   = $entry["time"];
		$title  = $entry["title"];
		$firstname = $entry["firstname"];
		$name   = $entry["name"];
		$profession = $entry["profession"];
		$mail   = $entry["mail"];
		$street = $entry["street"];
		$plz    = $entry["plz"];
		$city   = $entry["city"];
		$ip      = $entry["ip"];
		
		// Generate output string


		$outputstr = 
	 	"<tr>\n"
		  .'<td valign="top" id="guestbook_name">' . $title. " ". $firstname. " ". $name . "</td>"
		  ."<td id=\"guestbook_profession\" valign=\"top\">".$profession . "</td>\n"
		  .'<td id="guestbook_address" valign="top">'. $street . ", " . $plz . " " . $city . "</td>"
		."</tr>\n";

		return $outputstr;

	} // showentry



//----------------------------------------------------------------------------
// 	show entries on current guestbook page
//----------------------------------------------------------------------------

	// line of the file, where to start output
	$first_entry = $entries - ( $page * $entries_per_page ) + 1;
	if ($first_entry < 1) { $first_entry = 1; }

	// line of the file, where to stop output
	$last_entry = $entries - ( ($page-1) * $entries_per_page );
	if ($last_entry < 1) { $last_entry = 1; }

// show entries sorted by lifo

	$entrynum = $last_entry;

	$entry = array();
	$db->get_entrylist( $first_entry-1, $last_entry-1, $entry );

	$keys = array_keys( $entry );
	$keys = array_reverse( $keys );

	$i = $last_entry;
	foreach ($keys as $key)
	{

		$ready4print = showentry( $entry[$key], $i );
		echo <<<ENTRY
<tr>
  <td valign="top"><b>$i:</b>&nbsp;</td>
  <td align="middle"><p id="guestbook_edit"><a href="$PHP_SELF?action=delete&entry=$i&page=$page&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs">$_delete</a></p></td>
  <td>&nbsp;</td>
</tr>
$ready4print
ENTRY;

		$i--;

	}

echo <<<TABROW
<tr>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
   </tr>
</table>
TABROW;

	echo $pagenavigation;
	echo '<p>&nbsp;</p><p><a href="'.$PHP_SELF.'">'.$_back_to_main_menu.'</a></p>';

	exit;
}




// ============================= SAVE CONFIG FILE ============================


if ( !empty( $HTTP_GET_VARS["action"] ) && $HTTP_GET_VARS["action"] == "config" )
{
	// make sure logical variables have are "true" or "false"
	$HTTP_POST_VARS["input_name_new"]
	? $input_name_new = "true"
	: $input_name_new = "false";

	$HTTP_POST_VARS["input_email_new"]
	? $input_email_new = "true"
	: $input_email_new = "false";

	$HTTP_POST_VARS["input_age_new"]
	? $input_age_new = "true"
	: $input_age_new = "false";

	$HTTP_POST_VARS["input_city_new"]
	? $input_city_new = "true"
	: $input_city_new = "false";

	$HTTP_POST_VARS["input_homepage_new"]
	? $input_homepage_new = "true"
	: $input_homepage_new = "false";

	$HTTP_POST_VARS["input_icq_new"]
	? $input_icq_new = "true"
	: $input_icq_new = "false";

	$HTTP_POST_VARS["input_message_new"]
	? $input_message_new = "true"
	: $input_message_new = "false";

	$HTTP_POST_VARS["filter_multiposting_new"]
	? $filter_multiposting_new = "true"
	: $filter_multiposting_new = "false";

	$HTTP_POST_VARS["filter_badwords_new"]
	? $filter_badwords_new = "true"
	: $filter_badwords_new = "false";

	$HTTP_POST_VARS["filter_html_new"]
	? $filter_html_new = "true"
	: $filter_html_new = "false";

	$HTTP_POST_VARS["administrator_notification_new"]
	? $administrator_notification_new = "true"
	: $administrator_notification_new = "false";
	
	$fit_timezone
	? $fit_timezone = "true"
	: $fit_timezone = "false";

	$fh = fopen( $path_to_guestbook."globals.inc.php", "w" );

	$str2write = '<?php // Jax Petitionbook (basing on Jax Guestbook) v3.06 - globals.inc.php'."\n\n"

	."// This file can be changed comfortably by the guestbook.admin.php script\n"
	."// Global variables (perhaps have to be fitted) :\n\n"

	."// Title of the HTML-page\n"
	.'$gbfiles[0]->title         = "'.$HTTP_POST_VARS["htmltitle_new"].'";'."\n\n"

	."// Data source\n"
	.'$gbfiles[0]->data_source   = "'.$HTTP_POST_VARS["data_source_new"].'";'."\n\n"
	.'$gbfiles[0]->guestbookfile = "'.$HTTP_POST_VARS["guestbookfile_new"].'";'."\n"
	.'$gbfiles[0]->ipblockfile   = "'.$HTTP_POST_VARS["blocking_file_new"].'";'."\n\n"
	.'$gbfiles[0]->db_server     = "'.$HTTP_POST_VARS["db_server_new"].'";'."\n"
	.'$gbfiles[0]->db_login      = "'.$HTTP_POST_VARS["db_login_new"].'";'."\n"	
	.'$gbfiles[0]->db_database   = "'.$HTTP_POST_VARS["db_database_new"].'";'."\n"	
	.'$gbfiles[0]->db_password   = "'.$HTTP_POST_VARS["db_password_new"].'";'."\n\n"	
		
	."// CSS template for the Guestbook\n"
	.'$gbfiles[0]->css           = "'.$HTTP_POST_VARS["css_file_new"].'";'."\n\n"

	."// Inputs\n"
	.'$input_name                = '.$input_name_new.";\n"
	.'$input_email               = '.$input_email_new.";\n"
	.'$input_age                 = '.$input_age_new.";\n"
	.'$input_city                = '.$input_city_new.";\n"
	.'$input_homepage            = '.$input_homepage_new.";\n"
	.'$input_icq                 = '.$input_icq_new.";\n"
	.'$input_message             = '.$input_message_new.";\n\n";

	$index = array_keys( $gbfiles );
	foreach( $index as $id )
	{
		if ( $id != "0" )
		{
			$str2write .=
			  '$gbfiles['.$id.']->title         = "'. $gbfiles[$id]->title.'";'."\n"
			. '$gbfiles['.$id.']->data_source   = "'. $gbfiles[$id]->data_source.'";'."\n"
			. '$gbfiles['.$id.']->guestbookfile = "'. $gbfiles[$id]->guestbookfile.'";'."\n"
			. '$gbfiles['.$id.']->ipblockfile   = "'. $gbfiles[$id]->ipblockfile.'";'."\n"
			. '$gbfiles['.$id.']->db_server     = "'. $gbfiles[$id]->db_server.'";'."\n"
			. '$gbfiles['.$id.']->db_login      = "'. $gbfiles[$id]->db_login.'";'."\n"
			. '$gbfiles['.$id.']->db_database   = "'. $gbfiles[$id]->db_database.'";'."\n"
			. '$gbfiles['.$id.']->db_password   = "'. $gbfiles[$id]->db_password.'";'."\n"
			. '$gbfiles['.$id.']->css = "'. $gbfiles[$id]->css.'";'."\n\n";
		}
	}

	$str2write .=
	"// if no guestbook_id is given in URI, take default (0)\n"
	.'if (!empty( $HTTP_GET_VARS[ "guestbook_id" ] ) )'."\n"
	.'  $guestbook_id = $HTTP_GET_VARS[ "guestbook_id" ];'."\n"
	.'else'."\n"
	.'  $guestbook_id = 0;'
	."\n\n"

	.'$htmltitle     = $gbfiles[$guestbook_id]->title;'."\n"
	.'$data_source   = $gbfiles[$guestbook_id]->data_source;'."\n"
	.'$guestbookfile = $gbfiles[$guestbook_id]->guestbookfile;'."\n"
	.'$blocking_file = $gbfiles[$guestbook_id]->ipblockfile;'."\n"
	.'if ($data_source == "mysql" )'."\n"
	.'{'."\n"
	.'$db_server     = $gbfiles[$guestbook_id]->db_server;'."\n"
	.'$db_login      = $gbfiles[$guestbook_id]->db_login;'."\n"
	.'$db_database   = $gbfiles[$guestbook_id]->db_database;'."\n"
	.'$db_password   = $gbfiles[$guestbook_id]->db_password;'."\n"
	.'}'."\n\n"
	.'$css_file      = $gbfiles[$guestbook_id]->css;'."\n\n"

	."// Language support\n"
	.'if ( empty( $HTTP_GET_VARS[ "language" ] ) )'."\n"
	."{\n"
	.'    $languagepack = "'.$HTTP_POST_VARS["languagepack_new"].'";'."\n"
	."}\n"
	."else\n"
	."{\n"
	.'    $languagepack = $HTTP_GET_VARS[ "language" ];'."\n"
	."}\n\n"

	."// fit date to time zone\n"
	.'$fit_timezone      = '.$fit_timezone.";\n\n"

	."// how many guestbook entries shell be output per page?\n"
	.'$entries_per_page  = '.$HTTP_POST_VARS["entries_per_page_new"].";\n\n"

	."// Maximum of bad words, till the posting will be denied\n"
	.'$insults_tolerance = '.$HTTP_POST_VARS["insults_tolerance_new"].";\n\n"

	."// Duration (in hours), the IPs of spammers have to be blocked\n"
	.'$blocking_period   = '.$HTTP_POST_VARS["blocking_period_new"].";\n\n"

	."// Maximum size of a Message in Bytes\n"
	.'$max_message_size  = '.$HTTP_POST_VARS["max_message_size_new"].";\n\n"

	."// Filter\n"
	.'$filter_multiposting = '.$filter_multiposting_new.";\n"
	.'$filter_badwords     = '.$filter_badwords_new.";\n"
	.'$filter_html         = '.$filter_html_new.";\n\n"

	."// e-mail Notification\n"
	.'$administrator_notification = '.$administrator_notification_new.";\n"
	.'$administrator_address = "'.$HTTP_POST_VARS["administrator_address_new"].'"'.";\n\n"
	
	.'if (!empty( $_SERVER["PHP_SELF"] ))'."\n"
  	.'  $PHP_SELF = $_SERVER["PHP_SELF"];'."\n\n"

	.'if (!empty( $_SERVER["SCRIPT_NAME"] ) )'."\n"
  	.'  $SCRIPT_NAME = $_SERVER["SCRIPT_NAME"];'."\n\n"

	.'if (!empty( $_SERVER["SERVER_NAME"] ) )'."\n"
  	.'  $SERVER_NAME = $_SERVER["SERVER_NAME"];'."\n\n"
  
	.'if (!empty( $_SERVER["REMOTE_ADDR"] ) )'."\n"
  	.'  $REMOTE_ADDR = $_SERVER["REMOTE_ADDR"];'."\n\n"

	.'?>';

	fputs( $fh, $str2write );

	echo "$_saved...<br><br>";
	fclose( $fh );

}


if ( !empty( $HTTP_GET_VARS["action"] ) && $HTTP_GET_VARS["action"] == "settings" )
{
// look for language templates in the language directory

	$langs = array();

	$lang_dir = dir( $path_to_guestbook."language" );
	while ( $entry = $lang_dir->read() )
	{
		$entry = eregi_replace( ".inc.php$","",$entry );

		if ( !ereg( "\.", $entry ) )
		{
			$langs[ ] = $entry;
		}
	}

	sort( $langs );
	$xlangs = array_values( $langs );
	$languagelist = "";
	foreach ($xlangs as $xlang )
	{
		if ( $languagepack == $xlang )
		{
			$languagelist .= "<option selected>".$xlang."</option>";
		}
		else
		{
			$languagelist .= "<option>".$xlang."</option>";
		}

	}

if ($data_source == "mysql")
{
	$csvoption = ''; $mysqloption = 'checked';
}
else
{
	$csvoption = 'checked'; $mysqloption = '';
}

if ( $input_name ) { $input_name_option = "checked"; } else { $input_name_option = ""; }
if ( $input_email ) { $input_email_option = "checked"; } else { $input_email_option = ""; }
if ( $input_city ) { $input_city_option = "checked"; } else { $input_city_option = ""; }
if ( $input_age ) { $input_age_option = "checked"; } else { $input_age_option = ""; }
if ( $input_homepage ) { $input_homepage_option = "checked"; } else { $input_homepage_option = ""; }
if ( $input_icq ) { $input_icq_option = "checked"; } else { $input_icq_option = ""; }
if ( $input_message ) { $input_message_option = "checked"; } else { $input_message_option = ""; }
if ( $filter_html ) { $filter_html_option = "checked"; } else { $filter_html_option = ""; }
if ( $filter_multiposting ) { $filter_multiposting_option = "checked"; } else { $filter_multiposting_option = ""; }
if ( $filter_badwords ) { $filter_badwords_option = "checked"; } else { $filter_badwords_option = ""; }
if ( $administrator_notification ) { $administrator_notification_option = "checked"; } else { $administrator_notification_option = ""; }

if ( empty( $db_server ) ) { $db_server = ""; }
if ( empty( $db_login ) ) { $db_login = ""; }
if ( empty( $db_password ) ) { $db_password = ""; }
if ( empty( $db_database ) ) { $db_database = ""; }

echo <<<MENU
<form name="globalsettingsform" method="post" action="$PHP_SELF?action=config&gmt_ofs=$gmt_ofs" class="guestbook">
  <table width="85%" border="1" bordercolor="#000000" cellpadding="3" cellspacing="0" align="center">
    <tr>
      <td>
        <table width="100%" border="0" align="center">
          <tr>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;</td>
            <td>
              <p>&nbsp;</p>
            </td>
            <td></td>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td><a href="$PHP_SELF?action=list&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs"> $_edit_guestbook </a></td>
            <td>
              <input type="submit" name="send" value="$_save_settings">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td></td>
            <td></td>
          </tr>
          <tr>
            <td></td>
            <td></td>
            <td>&nbsp; </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td></td>
            <td></td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td> $_language: </td>
            <td>
              <select name="languagepack_new"> $languagelist

              </select>
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td></td>
            <td></td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td> $_data_source: </td>
            <td>
              <input type="radio" name="data_source_new" value="csvfile" $csvoption >
              $_csv_file
              <input type="radio" name="data_source_new" value="mysql" $mysqloption>
              $_mysql_database</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td> $_guestbook_table: </td>
            <td>
              <input type="text" name="guestbookfile_new" size="40" value="$guestbookfile">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td> $_server: *</td>
            <td>
              <input type="text" name="db_server_new" size="40" value="$db_server">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td> $_login: *</td>
            <td>
              <input type="text" name="db_login_new" size="40" value="$db_login">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td> $_password: *</td>
            <td>
              <input type="password" name="db_password_new" size="40" value="$db_password">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td> $_database: *</td>
            <td>
              <input type="text" name="db_database_new" size="40" value="$db_database">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td><font size="1">* $_footnote</font></td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td></td>
            <td></td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td></td>
            <td></td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>$_caption:</td>
            <td>
              <input type="text" name="htmltitle_new" size="40" value="$htmltitle">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td> $_used_stylesheet: </td>
            <td>
              <input type="text" name="css_file_new" size="40" value="$css_file">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td></td>
            <td></td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td> $_inputs:</td>
            <td>
              <input type="checkbox" name="input_name_new" value="true" $input_name_option >
              $_name</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td></td>
            <td></td>
            <td>
              <input type="checkbox" name="input_email_new" value="true" $input_email_option >
              $_mailaddress</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td></td>
            <td></td>
            <td>
              <input type="checkbox" name="input_age_new" value="true" $input_age_option >
              $_age</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td></td>
            <td></td>
            <td>
              <input type="checkbox" name="input_city_new" value="true" $input_city_option >
              $_city</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td></td>
            <td></td>
            <td>
              <input type="checkbox" name="input_homepage_new" value="true" $input_homepage_option >
              $_homepage</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td></td>
            <td></td>
            <td>
              <input type="checkbox" name="input_icq_new" value="true" $input_icq_option >
              $_icq</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td></td>
            <td></td>
            <td>
              <input type="checkbox" name="input_message_new" value="true" $input_message_option >
              $_message</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td></td>
            <td></td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td></td>
            <td></td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td> $_entries_per_page: </td>
            <td>
              <input type="text" name="entries_per_page_new" size="40" value="$entries_per_page">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td> $_max_entry_size: </td>
            <td>
              <input type="text" name="max_message_size_new" size="10" value="$max_message_size">
              $_bytes </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td></td>
            <td></td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>$_admin_notification:</td>
            <td>
              <input type="checkbox" name="administrator_notification_new" value="true" $administrator_notification_option >
            </td>
            <td></td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>$_admin_address:</td>
            <td>
              <input type="text" name="administrator_address_new" size="40" value="$administrator_address">
            </td>
            <td></td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td></td>
            <td></td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>$_filters:</td>
            <td>
              <input type="checkbox" name="filter_multiposting_new" value="true" $filter_multiposting_option >
              $_multi_posting</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td></td>
            <td></td>
            <td>
              <input type="checkbox" name="filter_badwords_new" value="true" $filter_badwords_option >
              $_bad_words</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td></td>
            <td></td>
            <td>
              <input type="checkbox" name="filter_html_new" value="true" $filter_html_option >
              $_html</td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td></td>
            <td></td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td> $_badwords_sensitivity: </td>
            <td>
              <input type="text" name="insults_tolerance_new" size="40" value="$insults_tolerance">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td> $_blocking_table: </td>
            <td>
              <input type="text" name="blocking_file_new" size="40" value="$blocking_file">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td> $_blocking_period: </td>
            <td>
              <input type="text" name="blocking_period_new" size="40" value="$blocking_period">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td></td>
            <td></td>
          </tr>
          <tr>
            <td></td>
            <td></td>
            <td>
              <input type="submit" name="send" value="$_save_settings">
            </td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td></td>
            <td></td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
          </tr>
        </table>
      </td>
    </tr>
  </table>
  </form>
MENU;

exit;
}

echo <<<MENU
<p align="center">&nbsp;</p>
<table border="0" align="center">
  <tr>
    <td><a href="$PHP_SELF?action=list&guestbook_id=$guestbook_id&gmt_ofs=$gmt_ofs">$_edit_guestbook</a></td>
  </tr>
  <tr>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td><a href="$PHP_SELF?action=settings&gmt_ofs=$gmt_ofs">$_change_config</a></td>
  </tr>
  <tr>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td><img src="http://www.jtr.de/scripting/php/guestbook/updateinfo/updateinfo.php?img=status&current_version=306">&nbsp;&nbsp;<a href="http://www.jtr.de/scripting/php/guestbook/updateinfo/updateinfo.php?current_version=306" target="_blank">$_check4updates</a></td>
  </tr>
  <tr>
    <td>&nbsp;</td>
  </tr>
</table>
MENU;


?>

<p>&nbsp;</p>
<p>&nbsp;</p>
<!-- Please don't remove the link to the author's website!!! -->
<p><font size="1" color="#BBBBBB">Jax Petitionbook (basing on Jax Guestbook) v3.06 by Jack (tR),
<a href="http://www.jtr.de/scripting/php">www.jtr.de/scripting/php</a>
</font></p>

</body>
</html>
